package net.java.amateras.uml.editpart;

import java.beans.PropertyChangeEvent;

import net.java.amateras.uml.UMLPlugin;
import net.java.amateras.uml.model.CompositeModel;

import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.ConnectionLocator;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.geometry.PointList;

public class CompositeEditPart extends AbstractUMLConnectionEditPart {
	
	private Label labelStereoType;
	private Label labelFromMultiplicity;
	private Label labelToMultiplicity;
	
	protected IFigure createFigure() {
		CompositeModel model = (CompositeModel)getModel();
		
		labelStereoType = new Label();
		if(!model.getStereoType().equals("")){
			labelStereoType.setText("<<" + model.getStereoType() + ">>");
		}
		
		labelFromMultiplicity = new Label();
		labelFromMultiplicity.setText(model.getFromMultiplicity());
		
		labelToMultiplicity = new Label();
		labelToMultiplicity.setText(model.getToMultiplicity());
		
		PolylineConnection connection = new PolylineConnection();
		connection.setConnectionRouter(UMLPlugin.getDefault().getConnectionRouter());
		connection.add(labelStereoType, new ConnectionLocator(connection, ConnectionLocator.MIDDLE));
		
		ConnectionEndpointLocator sourceEndpointLocator = new ConnectionEndpointLocator(connection, false);
		sourceEndpointLocator.setVDistance(15);
		connection.add(labelFromMultiplicity, sourceEndpointLocator);
		
		ConnectionEndpointLocator targetEndpointLocator = new ConnectionEndpointLocator(connection, true);
		targetEndpointLocator.setVDistance(15);
		connection.add(labelToMultiplicity, targetEndpointLocator);
		
		PolygonDecoration decoration = new PolygonDecoration();
		PointList decorationPointList = new PointList();
		decorationPointList.addPoint( 0, 0);
		decorationPointList.addPoint(-2, 2);
		decorationPointList.addPoint(-4, 0);
		decorationPointList.addPoint(-2,-2);
		decoration.setTemplate(decorationPointList);
		connection.setTargetDecoration(decoration);
		
		return connection;
	}
	
	public void propertyChange(PropertyChangeEvent evt) {
		CompositeModel model = (CompositeModel)getModel();
		labelFromMultiplicity.setText(model.getFromMultiplicity());
		labelToMultiplicity.setText(model.getToMultiplicity());
		
		if(!model.getStereoType().equals("")){
			labelStereoType.setText("<<" + model.getStereoType() + ">>");
		} else {
			labelStereoType.setText("");
		}
		
		refreshVisuals();
	}

	protected Label getStereoTypeLabel() {
		return labelStereoType;
	}
	
}
