package net.java.amateras.uml.model;

import net.java.amateras.uml.UMLPlugin;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;

/**
 * C^[tF[XfIuWFNgB
 * 
 * @author Naoki Takezoe
 */
public class InterfaceModel extends AbstractUMLEntityModel implements EntityModel {
	
	public static final String P_NAME = "_class_name";
	
	private String name = "";
	private static int number = 1;
	
	public InterfaceModel(){
		setName("Interface" + number);
		number++;
	}
	
	public void setName(String interfaceName){
		String oldName = this.name;
		this.name = interfaceName;
		firePropertyChange(P_NAME , oldName ,interfaceName);
	}
	
	public String getName(){
		return this.name;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		return new IPropertyDescriptor[]{
				new TextPropertyDescriptor(P_NAME, 
						UMLPlugin.getDefault().getResourceString("property.name")),
		};
	}

	public Object getPropertyValue(Object id) {
		if(id.equals(P_NAME)){
			return getName();
		}
		return null;
	}

	public boolean isPropertySet(Object id) {
		if(id.equals(P_NAME)){
			return true;
		}
		return false;
	}

	public void setPropertyValue(Object id, Object value) {
		if(id.equals(P_NAME)){
			setName((String)value);
		}
	}
	
}
